<?

namespace de\IPSymcon\ernie;

/**********************************************
 ***
 *** INTERFACE Heizungskomponenten
 ***
 ***/
interface HeizungsKomponenten {
	// Heizungs Funktionen
	public function __construct($varConfigObject);
	public function getSollTemperatur ($raumName);
	public function setSollTemperatur ($raumName,$sollTemperatur,$grund);
	public function getWindowStatus ($objectID);
	
	// Fenster Stati-Funktionen
	public function getOpendWindowValue();
	public function getTitedWindowValue();
	public function getClosedWindowValue();
}

/**********************************************
 ***
 *** IMPLEMENTATIONS OF INTERFACE Heizungskomponenten
 ***
 ***/
class HomeMaticKomponenten implements HeizungsKomponenten {
	private $configObject;
	
	public function __construct($varConfigObject) {
		$this->configObject = $varConfigObject;
		$this->configObject->showEnvironmentDebugMessage("Object HomeMaticKomponenten erstellt" ,"homeMaticKomponenten.class[__construct]",1);
	}

	public function getSollTemperatur ($raumName) {
		$this->configObject->showEnvironmentDebugMessage('call getSollTemperatur("'. $raumName.'")' ,"homeMaticKomponenten.class[getSollTemperatur]",1);
	   $setPointID = $this->configObject->getReadRaumSollTemperaturObjectID($raumName);
		$this->configObject->showEnvironmentDebugMessage('   $setPointID == '. $setPointID ,"homeMaticKomponenten.class[getSollTemperatur]",1);
		$result = GetValueFloat($setPointID);
		$this->configObject->showEnvironmentDebugMessage('   $result == '. $result ,"homeMaticKomponenten.class[getSollTemperatur]",1);
		return $result ;
	}

	public function setSollTemperatur ($raumName,$wunschTemperatur,$grund) {
	   $setPointID = $this->configObject->getWriteRaumSollTemperaturObjectID($raumName);
		$result = HM_WriteValueFloat($setPointID, "SETPOINT", $wunschTemperatur);
		if ($result) {
		   IPS_LogMessage("HomeMaticKomponenten.class","Temperatur fr Heizkrper ". $raumName ." auf " . $wunschTemperatur . " gesetzt; Grund: ". $grund);
		   }
		else {
		   IPS_LogMessage("HomeMaticKomponenten.class","MISSLUNGENER Versuch, Temperatur fr Heizkrper ". $raumName ." auf " . $wunschTemperatur . " zu setzen");
		}
		return $result;
	}

	public function getWindowStatus ($objectID) {
      return GetValueInteger($objectID);
	}

	// Fenster Stati-Funktionen fr HomeMatic
	public function getOpendWindowValue() {
		// $FENSTER_OFFEN = 2;
		return 2;
	}

	public function getTitedWindowValue() {
		// $FENSTER_GEKIPPT = 1;
		return 1;
	}

	public function getClosedWindowValue() {
      // $FENSTER_GESCHLOSSEN = 0;
      return 0;
	}

}
?>