<?

/*
 ################################################################################
 # IP-Symcon Config-Datei                                                       #
 #                                                                              #
 # Beschreibung : config Datei zu IP-Symcon                                     #
 # Create date  : 2010-11-05                                                    #
 # Last change  : 2010-11-05                                                    #
 # Version      : 0.09                                                          #
 # Datei        : config.class.ips.php                                          #
 # Author       : ernie                                                         #
 # Copyright    : ernie                                                         #
 ################################################################################
 */

namespace de\IPSymcon\ernie;

if (!defined("INCLUDED_DEBUGGER")) {
	DEFINE("INCLUDED_DEBUGGER",TRUE);
	include("debugger.class.ips.php");
	}

class Config implements EnvironmentDebugger {
	private $version;
	private $debug;
	private $heizungssteuerung;
	private $ipsConfigObjectIDs;
	
	public function __construct($myVersion) {
		$this->timeBegin = microtime();
		$this->version = $myVersion;
		$this->debug = array();
		$this->debug['showHiddenThings']			= true;
		$this->debug['debugThisSession']			= false;
		$this->debug['showDebugMessageOnEnd']	= false;
		$this->debug['debugWithPRE']				= false;

		$this->debug['disableWarnings']			= false;
		$this->debug['disableOutput']				= false;

		if ($this->debug['disableWarnings']) {
			error_reporting(E_ERROR);
			// alle ohne NOTICE:
			// error_reporting(E_ALL & ~E_NOTICE);
		}

		$this->environmentDebugConfigObject = new EnvironmentDebugObject();

		$do = $this->environmentDebugConfigObject;
		// echo "<PRE>". $this->environmentDebugConfigObject . "</PRE><br>\n";
		// $this->environmentDebugConfigObject->addDebugEnvironment('environmentName',	0,	PRE?,	show Categories?,showCount,	OnEnd,	uesedDebuggers);
		$do->addDebugEnvironment('config.class[getWunschTemperatur]',							0,	TRUE,	TRUE,	FALSE,	FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1

		$do->addDebugEnvironment('heizungssteuerung_createHeizplan.class[__construct]',	0,	TRUE,	TRUE,	FALSE,	FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('heizungssteuerung_createHeizplan.class[initialzing]',	6,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 9

		$do->addDebugEnvironment('heizungssteuerung_trigger.class[__construct]',			0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[showActualHeizplan]',	6,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 7 / maxValue = 9
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[setActualTemperature]',6,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 7 / maxValue = 9
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[lookOpenWindows]',		6,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 7 / maxValue = 9
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[setRaumTemperatur]',	5,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 6 / maxValue = 9
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[lookAllRooms]',			7,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 8 / maxValue = 9

		$do->addDebugEnvironment('homeMaticKomponenten.class[__construct]',					0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('homeMaticKomponenten.class[getSollTemperatur]',			0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1

		// ##################################################
		// ###
		// ### DEFINE Heizungssteuerung
		// ###
		// ### Definition der ObjectIDs der Kategorien, in denen der Heizplan
		// ### der einzelnen Tage erstellt werden soll
		// ### LAST CHANGE IN IN REVISION 1
		$this->heizungssteuerung = array();
		$this->heizungssteuerung['rootNodesHeizplan'] = array();
		$this->heizungssteuerung['rootNodesHeizplan'][0] = 39943;
		$this->heizungssteuerung['rootNodesHeizplan'][1] = 39943;
		$this->heizungssteuerung['rootNodesHeizplan'][2] = 33124;
		$this->heizungssteuerung['rootNodesHeizplan'][3] = 45034;
		$this->heizungssteuerung['rootNodesHeizplan'][4] = 24413;
		$this->heizungssteuerung['rootNodesHeizplan'][5] = 42431;
		$this->heizungssteuerung['rootNodesHeizplan'][6] = 17169;
		$this->heizungssteuerung['rootNodesHeizplan'][7] = 24282;

		// ###
		// ### Definition der ObjectIDs, an denen die Raum-Soll-Temperaturen gelesen werden knnen
		// ### LAST CHANGE IN IN REVISION 2
		$this->heizungssteuerung['readRaumSollTemeratur'] = array();
		$this->heizungssteuerung['readRaumSollTemeratur']['Bad'] 			= 11496;
		$this->heizungssteuerung['readRaumSollTemeratur']['Bro']			= 57653;
		$this->heizungssteuerung['readRaumSollTemeratur']['Gstezimmer'] 	= 54771;
		$this->heizungssteuerung['readRaumSollTemeratur']['Schlafzimmer'] = 53751;
		$this->heizungssteuerung['readRaumSollTemeratur']['Wohnzimmer'] 	= 50601;

		// ###
		// ### Definition der ObjectIDs an denen die Raum-Soll-Temperaturen geschrieben werden knnen
		// ### Eventuell sind diese gleich "Gelesenen", bei HomeMatic jedoch nicht ...
		// ### dort wird die Variable ausgelsen, jedoch ins Thermostat zurckgeschrieben
		// ### LAST CHANGE IN IN REVISION 2
		$this->heizungssteuerung['writeRaumSollTemeratur'] = array();
		$this->heizungssteuerung['writeRaumSollTemeratur']['Bad'] 				= 36797;
		$this->heizungssteuerung['writeRaumSollTemeratur']['Bro']				= 19315;
		$this->heizungssteuerung['writeRaumSollTemeratur']['Gstezimmer'] 	= 31325;
		$this->heizungssteuerung['writeRaumSollTemeratur']['Schlafzimmer'] 	= 30084;
		$this->heizungssteuerung['writeRaumSollTemeratur']['Wohnzimmer'] 		= 42515;

		// ###
		// ### Definition der ObjectIDs, an denen die Raum-Ist-Temperaturen gelesen werden knnen
		// ### LAST CHANGE IN IN REVISION 2
		$this->heizungssteuerung['readRaumIstTemeratur'] = array();
		$this->heizungssteuerung['readRaumIstTemeratur']['Bad'] 			= 30941;
		$this->heizungssteuerung['readRaumIstTemeratur']['Bro']			= 39080;
		$this->heizungssteuerung['readRaumIstTemeratur']['Gstezimmer'] 	= 47279;
		$this->heizungssteuerung['readRaumIstTemeratur']['Schlafzimmer'] = 25826;
		$this->heizungssteuerung['readRaumIstTemeratur']['Wohnzimmer'] 	= 10100;

		// ###
		// ### Definition der ObjectIDs der Fenster-Kontakte
		// ### LAST CHANGE IN IN REVISION 2
		$this->heizungssteuerung['rootNodesFenster'] = array();
		$this->heizungssteuerung['rootNodesFenster']['Bad'] = array();
		$this->heizungssteuerung['rootNodesFenster']['Bad'][0] 				= 58608;

		// ###
		// ### Definition der ObjectIDs der IPS-Variablen, aus denen
		// ### die An-/Abwesend Wunsch-Temperaturen ausgelesen werden soll
		// ### Dort sollten FLOAT Variablen erstellt werden
		// LAST CHANGE IN IN REVISION 2
		$this->heizungssteuerung['temperaturProfile'] = array();
		$this->heizungssteuerung['temperaturProfile']['Bad'] = array();
		$this->heizungssteuerung['temperaturProfile']['Bad']['Anwesend'] 				= 14291;
		$this->heizungssteuerung['temperaturProfile']['Bad']['Abwesend'] 				= 17837;
		$this->heizungssteuerung['temperaturProfile']['Bro'] = array();
		$this->heizungssteuerung['temperaturProfile']['Bro']['Anwesend'] 			= 23609;
		$this->heizungssteuerung['temperaturProfile']['Bro']['Abwesend'] 			= 25567;
		$this->heizungssteuerung['temperaturProfile']['Gstezimmer'] = array();
		$this->heizungssteuerung['temperaturProfile']['Gstezimmer']['Anwesend'] 	= 16056;
		$this->heizungssteuerung['temperaturProfile']['Gstezimmer']['Abwesend'] 	= 32661;
		$this->heizungssteuerung['temperaturProfile']['Schlafzimmer'] = array();
		$this->heizungssteuerung['temperaturProfile']['Schlafzimmer']['Anwesend'] 	= 20055;
		$this->heizungssteuerung['temperaturProfile']['Schlafzimmer']['Abwesend'] 	= 18066;
		$this->heizungssteuerung['temperaturProfile']['Wohnzimmer'] = array();
		$this->heizungssteuerung['temperaturProfile']['Wohnzimmer']['Anwesend'] 	= 24623;
		$this->heizungssteuerung['temperaturProfile']['Wohnzimmer']['Abwesend'] 	= 10409;

		// ###
		// ### Definition der Zeit- und Standard-Anwesenheits-Profilen
		// ### inkl. der Aufteilung nach Wochentag / Wochenende
		// ### LAST CHANGE IN IN REVISION 1
		$this->heizungssteuerung['zeitProfile'] = array();
		$this->heizungssteuerung['standardZuordnung'] = array();

		// ### Raum Definitionen - Bad
		$this->heizungssteuerung['zeitProfile']['Bad'] = array();
		$this->heizungssteuerung['zeitProfile']['Bad'][0] = "06:00 bis 07:00 Uhr - Morgens";
		$this->heizungssteuerung['zeitProfile']['Bad'][1] = "07:00 bis 21:30 Uhr - Tagsber";
		$this->heizungssteuerung['zeitProfile']['Bad'][2] = "21:30 bis 23:00 Uhr - Abends";
		$this->heizungssteuerung['standardZuordnung']['Bad'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags']["06:00 bis 07:00 Uhr - Morgens"] 		= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags']["07:00 bis 21:30 Uhr - Tagsber"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags']["21:30 bis 23:00 Uhr - Abends"] 		= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende']["06:00 bis 07:00 Uhr - Morgens"] 	= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende']["07:00 bis 21:30 Uhr - Tagsber"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende']["21:30 bis 23:00 Uhr - Abends"] 	= TRUE;

		// ### Raum Definitionen - Bro
		$this->heizungssteuerung['zeitProfile']['Bro'] = array();
		$this->heizungssteuerung['zeitProfile']['Bro'][0] = "06:00 bis 12:00 Uhr - Morgens";
		$this->heizungssteuerung['zeitProfile']['Bro'][1] = "12:00 bis 19:30 Uhr - Tagsber";
		$this->heizungssteuerung['zeitProfile']['Bro'][2] = "19:30 bis 23:00 Uhr - Abends";
		$this->heizungssteuerung['standardZuordnung']['Bro'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bro']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bro']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bro']['Werktags']["06:00 bis 12:00 Uhr - Morgens"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Werktags']["12:00 bis 19:30 Uhr - Tagsber"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Werktags']["19:30 bis 23:00 Uhr - Abends"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Wochenende']["06:00 bis 12:00 Uhr - Morgens"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Wochenende']["12:00 bis 19:30 Uhr - Tagsber"] = FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Wochenende']["19:30 bis 23:00 Uhr - Abends"] 	= FALSE;

		// ### Raum Definitionen - Gstezimmer
		$this->heizungssteuerung['zeitProfile']['Gstezimmer'] = array();
		$this->heizungssteuerung['zeitProfile']['Gstezimmer'][0] = "07:00 bis 23:00 Uhr - Einheitlich";
		$this->heizungssteuerung['standardZuordnung']['Gstezimmer'] = array();
		$this->heizungssteuerung['standardZuordnung']['Gstezimmer']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Gstezimmer']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Gstezimmer']['Werktags']["07:00 bis 23:00 Uhr - Einheitlich"] = FALSE;
		$this->heizungssteuerung['standardZuordnung']['Gstezimmer']['Wochenende']["07:00 bis 23:00 Uhr - Einheitlich"] = FALSE;

		// ### Raum Definitionen - Schlafzimmer
		$this->heizungssteuerung['zeitProfile']['Schlafzimmer'] = array();
		$this->heizungssteuerung['zeitProfile']['Schlafzimmer'][0] = "07:00 bis 18:00 Uhr - Tagsber";
		$this->heizungssteuerung['zeitProfile']['Schlafzimmer'][1] = "18:00 bis 23:00 Uhr - Abends";
		$this->heizungssteuerung['zeitProfile']['Schlafzimmer'][2] = "23:00 bis 23:59 Uhr - Nachts";
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer'] = array();
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Werktags']["07:00 bis 18:00 Uhr - Tagsber"] = FALSE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Werktags']["18:00 bis 23:00 Uhr - Abends"] = TRUE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Werktags']["23:00 bis 23:59 Uhr - Nachts"] = FALSE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Wochenende']["07:00 bis 18:00 Uhr - Tagsber"] = FALSE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Wochenende']["18:00 bis 23:00 Uhr - Abends"] = TRUE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Wochenende']["23:00 bis 23:59 Uhr - Nachts"] = FALSE;

		// ### Raum Definitionen - Wohnzimmer
		$this->heizungssteuerung['zeitProfile']['Wohnzimmer'] = array();
		$this->heizungssteuerung['zeitProfile']['Wohnzimmer'][0] = "07:00 bis 12:00 Uhr - Morgens";
		$this->heizungssteuerung['zeitProfile']['Wohnzimmer'][1] = "12:00 bis 18:00 Uhr - Mittags";
		$this->heizungssteuerung['zeitProfile']['Wohnzimmer'][2] = "18:00 bis 23:00 Uhr - Abends";
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer'] = array();
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Werktags']["07:00 bis 12:00 Uhr - Morgens"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Werktags']["12:00 bis 18:00 Uhr - Mittags"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Werktags']["18:00 bis 23:00 Uhr - Abends"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Wochenende']["07:00 bis 12:00 Uhr - Morgens"] 	= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Wochenende']["12:00 bis 18:00 Uhr - Mittags"] 	= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Wochenende']["18:00 bis 23:00 Uhr - Abends"] 	= TRUE;

		// ############################################################################################
		// ###
		// ### Raum-Steuerungstechniken definieren:
		// ###
		// ### KEINE Erweiterte Raum-Steuerungstechnik
		// ###    Das Raum-Thermostat wird einfach auf die Wunsch-Temperatur gesetzt
		// ###
		// ### SIMPLE-DELTA Raumsteuerungstechnik
		// ###    Da einige Systeme den Raum hher heizen als gewnscht, kann
		// ###    hier ein DELTA-Wert angegeben werden, der auf von allen
		// ###    Wunsch-Temperaturen abgezogen wird
		// ###
		// ### BERSCHWAPPT-DELTA Raumstuuerungstechik (aktuell noch NICHT implementiert)
		// ###    Hier der Raum erst auf die Wunsch-Temperatur minus den jeweiligen Delta Wert
		// ###    hochheizt. Dann wird die tatschliche Wunsch-Temperatur gesetzt.
		// ###    Damit soll verhindert werden, dass die Raumtemperatur "berschwappt" bevor sich die
		// ###    Stellantriebe bei der Wunsch-Temperatur schlieen
		// ###
		// ###    Eventuelle DELTA-Werte aus SIMPLE-DELTA werden auch hier beachtet

		// Welche Technik soll fr welchen Raum benutzt werden?
		// LAST CHANGE IN REVISION 2
		$this->heizungssteuerung['raumSteuerungsTechnik'] = array();
		$this->heizungssteuerung['raumSteuerungsTechnik']['Bad'] 			= "SIMPLE-DELTA";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Bro'] 			= "KEINE";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Gstezimmer'] 	= "SIMPLE-DELTA";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Wohnzimmer'] 	= "SIMPLE-DELTA";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Schlafzimmer']	= "SIMPLE-DELTA";

		// Delta Werte, die beim "Hochheizen" eines Raumes vorerst von der Wunsch-Temperatur
		// abgezogen werden, bis die Wunsch-Temperatur minus Delta erreicht wird

		// SIMPLE-DELTA Werte definieren
		// Delta Werte, die fr die Soll-Temperatur des Raumes abgezogen wird
		// LAST CHANGE IN REVISION 2
		$this->heizungssteuerung['simpleDeltaTemperatur'] = array();
		$this->heizungssteuerung['simpleDeltaTemperatur']['Bad'] 			=  1.0;
		$this->heizungssteuerung['simpleDeltaTemperatur']['Bro'] 			= -1.0;
		$this->heizungssteuerung['simpleDeltaTemperatur']['Gstezimmer'] 	=  1.0;
		$this->heizungssteuerung['simpleDeltaTemperatur']['Schlafzimmer']	=  1.0;
		$this->heizungssteuerung['simpleDeltaTemperatur']['Wohnzimmer'] 	=  1.0;

		// BERSCHWAPP-DELTA Raum-Steuerungs-Definitionen
		/*
	   // TODO: in config verschieben?
	   // berschwappt-Abrechnungs-Delta
		// ist die Abrechnungs-Wert in %,
		// bei der der Raum auf die eigentliche Wunsch-Temperatur angehoben wird
	   // Beispiele:
	   //    - Wunsch-Temperatur = 18
	   //    - DeltaWert: 2 ==> Anheiz-Temperatur == 16 (18 - 2)
	   //
	   // 0    bedeutet, dass bei einer IST-Temperatur von 18,0 (18 - 0,0 /  0% von 2)
		//      die SOLL-Temperatur von 16 Anheizen auf 18 angehoben wird
		// 0.25 bedeutet, dass bei einer IST-Temperatur von 17,5 (18 - 0,5 / 25% von 2)
		//      die SOLL-Temperatur von 16 Anheizen auf 18 angehoben wird
	   // 1    bedeutet, dass bei einer IST-Temperatur von 16,0 (18 - 2,0 / 100% von 2)
		//      die SOLL-Temperatur von 16 Anheizen auf 18 angehoben wird
		$ueberschwapptDelta = 0.25;
		==> fr jeden Raum einzeln
		*/

		// ###
		// ### END DEFINE Heizungssteuerung
		// ###
		// ##############################################################

		// define other things
		$this->diverses = array();
		$this->diverses['newLine'] 					= "<br>\n";
		$this->diverses['newDebugLine'] 			= "\n";
		$this->diverses['HTMLDebugPlaceHolder'] 	= "&nbsp;&nbsp;&nbsp;";

		$this->diverses['color[black]'] 		= "#000000";
		$this->diverses['color[green]']		= "#009900";
		$this->diverses['color[red]'] 		= "#FF0000";
		$this->diverses['color[winered]']	= "#990000";
		$this->diverses['color[yellow]']		= "#FFFFCC";
	}

	public function getVersion() {
		return $this->version;
	}

	public function getWindowRootNodeForRoom($roomName) {
	   // returns Array, falls Fenster fr den Raum existieren
	   // returns -1, falls keine Fenster existieren
		if (isset($this->heizungssteuerung['rootNodesFenster'][$roomName])) {
			return $this->heizungssteuerung['rootNodesFenster'][$roomName];
		}
		else {
		   return -1;
		}
	}
	
	public function getRootNodeForDay($dayNumber) {
	   // 1 = Montag; 7 = Sonntag
		return $this->heizungssteuerung['rootNodesHeizplan'][$dayNumber];
	}

	public function getReadRaumSollTemperaturObjectID($raumName) {
		return $this->heizungssteuerung['readRaumSollTemeratur'][$raumName];
	}

	public function getRaumIstTemperatur($raumName) {
		return GetValueFloat($this->heizungssteuerung['readRaumIstTemeratur'][$raumName]);
	}

	public function getRaumSteuerungsTechnik($raumName) {
		return $this->heizungssteuerung['raumSteuerungsTechnik'][$raumName];
	}

	public function getSimpleDeltaTemperaturRaum($raumName) {
		return $this->heizungssteuerung['simpleDeltaTemperatur'][$raumName];
	}

	public function getWriteRaumSollTemperaturObjectID($raumName) {
		return $this->heizungssteuerung['writeRaumSollTemeratur'][$raumName];
	}

	public function getWunschTemperatur($raumName,$anwesenheit) {
	   $anwesenheitString = "";
		if ($anwesenheit) {$anwesenheitString = "Anwesend";}
		else {$anwesenheitString = "Abwesend";}
		$this->showEnvironmentDebugMessage('call getWunschTemperatur('. $raumName .','. $anwesenheitString .')' ,"config.class[getWunschTemperatur]",1);
		$result = GetValueFloat($this->heizungssteuerung['temperaturProfile'][$raumName][$anwesenheitString]);
		$this->showEnvironmentDebugMessage('   $result == '. $result ,"homeMaticKomponenten.class[getSollTemperatur]",1);
		return $result;
	}

	public function getZeitProfile() {
		return $this->heizungssteuerung['zeitProfile'];
	}

	public function getTemperaturProfile() {
		return $this->heizungssteuerung['temperaturProfile'];
	}

	public function getStandardZuordnung() {
		return $this->heizungssteuerung['standardZuordnung'];
	}

	public function getInitialAnwesendValue($raumName,$zeit,$actualWeekDay) {
		// $this->showEnvironmentDebugMessage('call getInitialAnwesendValue('. $raumName .','. $anwesenheit .')' ,"config.class[getWunschTemperatur]",1);
		// $this->configObject->showEnvironmentDebugMessage('   $result == '. $result ,"homeMaticKomponenten.class[getSollTemperatur]",1);
		if ($actualWeekDay <= 5) {
		   return $this->heizungssteuerung['standardZuordnung'][$raumName]['Werktags'][$zeit];
	   }
		else {
		   return $this->heizungssteuerung['standardZuordnung'][$raumName]['Wochenende'][$zeit];
		}
	}

	public function showEnvironmentDebugMessage ($message, $debugCategorie, $debugCount) {
		// delegate call
		$this->environmentDebugConfigObject->showEnvironmentDebugMessage($message, $debugCategorie, $debugCount);
	}

	 public function showDebugMessage ($message) {
	 // Dummy Methode, da tatsaechliche Ausgaben ueber showEnvironmentDebugMessage ausgegeben werden sollten
	 // TODO: EXCEPTION werfen
	 }

}

//Fgen Sie hier ihren Skriptquellcode ein

?>